/// <reference types="mousetrap" />
import React from 'react';
import PropTypes from 'prop-types';
declare type Combo = string | string[];
declare type ComboWithEventType = {
    combo: Combo;
    eventType?: string;
};
export declare type Sequence = Combo | ComboWithEventType;
export declare type Callback = (e: KeyboardEvent, combo: string) => any;
interface HotKeyContext {
    hotKeyParent: HotKeys;
    hotKeyMap: KeyMap;
}
export interface KeyMap {
    [key: string]: Sequence;
}
export interface Handlers {
    [key: string]: Callback;
}
export declare type Navigator = (hotKeys: HotKeys) => string | string[] | null;
interface HotKeysProps extends React.HTMLAttributes<HTMLElement> {
    children: React.ReactNode;
    name?: string;
    keyMap?: KeyMap;
    onFocus?: React.FocusEventHandler;
    onBlur?: React.FocusEventHandler;
    handlers?: Handlers;
    style?: React.CSSProperties;
    className?: string;
    focusOnMount?: boolean;
    navigator?: {
        [key: string]: string | string[] | Navigator | null;
    };
}
export declare class HotKeys extends React.Component<HotKeysProps, {}> {
    static contextTypes: {
        hotKeyParent: PropTypes.Requireable<any>;
        hotKeyMap: PropTypes.Requireable<object>;
    };
    static childContextTypes: {
        hotKeyParent: PropTypes.Requireable<any>;
        hotKeyMap: PropTypes.Requireable<object>;
    };
    static defaultProps: {
        focusOnMount: boolean;
    };
    context: HotKeyContext;
    wrappedComponent: React.RefObject<HTMLDivElement>;
    dom: HTMLElement | null;
    mounted: boolean;
    hotKeyMap: KeyMap;
    mousetrap: MousetrapInstance;
    name?: string;
    hotKeyChain: HotKeys[];
    constructor(props: HotKeysProps);
    getChildContext(): HotKeyContext;
    componentWillMount(): void;
    componentDidMount(): void;
    componentDidUpdate(prevProps: HotKeysProps): void;
    componentWillUnmount(): void;
    buildMap(): {
        [x: string]: Sequence;
    };
    updateMap(): boolean;
    navigateTo: (target: string | string[] | null) => void;
    updateHotKeys(force?: boolean, prevProps?: HotKeysProps): void;
    render(): JSX.Element;
}
export default HotKeys;
